<template>
  <div class="main-wrapper">
    <div id="main-menu" class="main-menu-show">
      <div id="currently-reading">
        <div class="title-panel">
          <h2 class="title-text">
            {{ $t("MainMenu.currently_reading") }}
          </h2>
          <div class="icon-title">
            <span id="article-title">
              <span id="article-title-tooltip" class="article-tooltip">{{ articleTitle }}</span>
              {{ articleTitle }}
            </span>
          </div>
        </div>
      </div>
      <div class="feature-panel">
        <div id="get-filter">
          <button class="feature-link f-icon" tabindex="0" v-on:click="$router.push('/filters')">{{ $t("MainMenu.filters") }}
            <img src="@/assets/collapsed.svg" alt="Filters" />
          </button>
        </div>
      </div>
      <div class="button-panel">
        <button :class="{
              'btn btn-primary': scanFullEnabled,
              'btn btn-disabled': !scanFullEnabled,
            }" type="button" id="full-scan-button" v-on:click="scanFullPage()" :disabled="!scanFullEnabled">
          {{ $t("MainMenu.scan_whole_page") }}
        </button>
        <button :class="{
              'btn btn-secondary': scanHighlightedEnabled,
              'btn btn-disabled': !scanHighlightedEnabled,
            }" id="highlighted-scan-button" v-on:click="scanHighlightedText()" :disabled="!scanHighlightedEnabled">
          {{ $t("MainMenu.scan_highlighted") }}
        </button>
      </div>
    </div>
    <div id="loader-block" class="loader-block">
      <div class="spinner" id="loading-bar-spinner">
        <div class="spinner-icon"></div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Vue } from "vue-class-component";

export default class MainMenu extends Vue {
  title = null;
  scanFullEnabled = true;
  scanHighlightedEnabled = false;

  get articleTitle() {
    return this.title ?? this.$t("MainMenu.page_name_unavailable");
  }

  mounted() {
    this.setLanguage();

    chrome.tabs.query(
      { active: true, currentWindow: true },
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      (tabs: any) => {
        chrome.tabs.sendMessage(
          tabs[0].id,
          { type: "check-highlight-scan" },
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          (response: any) => {
            if (chrome.runtime.lastError == null) {
              this.scanHighlightedEnabled = response.enable;
            } else {
              this.scanFullEnabled = false;
            }
          },
        );

        chrome.tabs.sendMessage(
          tabs[0].id,
          { type: "get-title" },
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          (response: any) => {
            if (chrome.runtime.lastError == null) {
              this.title = response;
            } else {
              this.scanFullEnabled = false;
            }
          },
        );
      },
    );
  }

  setLanguage() {
    chrome.runtime.sendMessage({ type: "get-settings" }, (response) => {
      if (response) {
        if (response.defaultSettings) {
          response.activeSettings.hidden.settings.languageSelection.value =
            navigator.language.includes("fr") ? false : true;

          chrome.runtime.sendMessage({
            type: "set-settings",
            settings: response.activeSettings,
          });
        }

        this.$i18n.locale = response.activeSettings.hidden.settings
          .languageSelection.value
          ? "en"
          : "fr";
      }
    });
  }

  scanFullPage() {
    chrome.tabs.query(
      { active: true, currentWindow: true },
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      (tabs: any) => {
        chrome.tabs.sendMessage(
          tabs[0].id,
          { type: "full-page-scan" },
          (response) => {
            if (response && response.type == "success") {
              window.close();
            }
          },
        );
      },
    );
  }

  scanHighlightedText() {
    if (this.scanHighlightedEnabled) {
      chrome.tabs.query(
        { active: true, currentWindow: true },
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        (tabs: any) => {
          chrome.tabs.sendMessage(
            tabs[0].id,
            { type: "highlighted-text-scan" },
            (response) => {
              if (response && response.type == "success") {
                window.close();
              }
            },
          );
        },
      );
    }
  }
}
</script>
<style>
@import url("https://fonts.googleapis.com/css2?family=Inter:wght@100;400&display=swap");

body {
  width: 390px;
  padding: 0;
  margin: 0;
  font-family: "Inter", sans-serif;
}

.popup-height {
  height: 450px;
  overflow: scroll;
}

.main-section {
  position: relative;
}

.main-box {
  padding-top: 61px;
  height: 388px;
  width: 100%;
  overflow: hidden;
  position: relative;
  z-index: 1;
}

.main-box-scroll {
  overflow: auto;
}

.main-menu-show {
  width: 100%;
  position: relative;
}

.main-menu-hide {
  width: 100%;
  position: absolute;
}

.main-wrapper {
  position: relative;
}

.btn {
  width: 100%;
  text-decoration: none;
  display: block;
  text-align: center;
  padding: 10px 10px;
  border-radius: 10px;
  border: 1px solid #083943;
  margin-bottom: 10px;
  cursor: pointer;
  font-weight: 600;
  font-family: "Inter", sans-serif;
  font-size: 14px;
}

.btn-primary {
  background-color: #083943;
  color: white;
}

.btn-primary:hover {
  background-color: #438f9d;
  color: white;
}

.btn-secondary {
  color: #083943;
  background-color: white;
  border: 1px solid #083943;
}

.btn-secondary:hover {
  background-color: #d4e9ed;
  color: #083943;
  border: 1px solid #083943;
}

.btn-disabled {
  background-color: #6c747a;
  border-color: #6c747a;
  border-radius: 10px;
  color: white;
  pointer-events: none;
}

/* Header Section Start */
.h-logo {
  width: 30px;
  display: flex;
  align-items: center;
  /* border-radius: 50%;
    border: 0.5px solid black; */
}

.settings-box {
  display: flex;
  align-items: center;
  margin-right: 4px;
}

.language-switch {
  margin-left: 5px;
  margin-right: 5px;
  padding: 0px;
}

.language-button {
  cursor: pointer;
  border: none;
  background-color: initial;
}

.language-button-active {
  color: #083943;
  font-weight: 900;
}

.header-box {
  position: relative;
  width: auto;
  display: flex;
  align-items: center;
  justify-content: space-between;
  padding: 16px 8px;
  border-bottom: 1px solid #dddddd;
}

.header-box .logo-panel {
  display: flex;
  align-items: center;
  margin-left: 4px;
}

.header-box .logo-panel h1 {
  font-weight: 600;
  font-size: 18px;
  line-height: 22px;
  margin: 0;
  padding-left: 8px;
}

#main-header {
  position: fixed;
  width: 100%;
  top: 0;
  left: 0;
  z-index: 20;
  background-color: white;
}

/* Header Section End */

/* Title Panel Start */
.title-panel {
  position: relative;
  width: auto;
  background-color: #eff4f5;
  padding: 8px 12px;
}

.title-text {
  font-weight: 400;
  margin: 0 0 5px 0;
  font-size: 16px;
  display: block;
}

.title-space {
  margin: 0;
  padding: 10px 15px 10px 15px;
}

.icon-title {
  position: relative;
  display: flex;
  align-items: center;
}

.icon-title img {
  margin-right: 4px;
}

.icon-title>span {
  height: 20px;
  width: 100%;
  margin: 0 0 0 0;
  font-size: 14px;
  display: inline-block;
  font-weight: 400;
  overflow: hidden;
}

.article-tooltip {
  position: absolute;
  bottom: -5px;
  right: 0;
  background-color: #081920;
  font-size: 11px;
  width: 150px;
  display: inline-block;
  padding: 5px;
  border-radius: 3px;
  color: white;
  display: none;
  word-break: break-word;
  white-space: -webkit-nowrap;
  z-index: 20;
  overflow: visible;
  transform: translate(0%, 100%);
}

.article-tooltip:before {
  content: "";
  position: absolute;
  top: -5px;
  left: 10px;
  border-left: 7px solid transparent;
  border-right: 7px solid transparent;
  border-bottom: 7px solid #081920;
}

.icon-title span:hover .article-tooltip {
  display: block;
}

/* Title Panel End */

/* Feature panel Start */
.feature-panel {
  position: relative;
  min-height: 216px;
  background-color: #ffffff;
  z-index: 5;
}

.show-highlight-settings div {
  border-bottom: 1px solid #e3e3e3;
}

.feature-link {
  padding: 12px 12px;
  font-size: 16px;
  font-weight: 500;
  display: flex;
  align-items: center;
  justify-content: space-between;
  text-decoration: none;
  color: #000000;
  background-color: #ffffff;
  cursor: pointer;
}

.feature-link:hover {
  background-color: #d6dfe3;
}

.filter-data-show {
  border: 0 !important;
}

.filter-data-show {
  height: 254px;
  overflow: auto;
  overflow-x: hidden;
  width: 100%;
  transition: all 0.5s ease;
}

.feature-text {
  padding: 12px 14px 4px 14px;
  font-size: 14px;
  font-weight: 400;
  align-items: center;
  color: #878888;
  display: flex;
  border: none !important;
}

.feature-text.relevance-score {
  color: #333333;
}

.back-btn {
  justify-content: start;
  border: none;
  border-bottom: 1px solid #e3e3e3;
  width: 100%;
}

.back-btn .back-icon {
  margin: 0 10px 0 0;
  pointer-events: none;
}

.f-icon {
  width: 100%;
  border: none;
  border-top: 1px solid #e3e3e3;
  border-bottom: 1px solid #e3e3e3;
}

/* Feature panel End */

/* Button panel Start */
.button-panel {
  position: relative;
  padding: 15px 10px 15px 10px;
}

.button-panel .btn:last-child {
  margin: 0;
}

/* Button panel End */

/* Custom check box start */
.custom-checkbox {
  display: block;
  position: relative;
  padding-left: 0;
  margin-bottom: 0;
  cursor: pointer;
  font-size: 14px;
  color: #333333;
  padding: 10px 15px;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

.custom-checkbox input {
  position: absolute;
  opacity: 0;
  cursor: pointer;
  height: 0;
  width: 0;
}

.checkmark {
  position: absolute;
  top: 50%;
  right: 0;
  transform: translate(-50%, -50%);
  height: 20px;
  width: 20px;
  border-radius: 2px;
  background-color: #eee;
}

.custom-checkbox:hover input~.checkmark {
  background-color: #ccc;
}

.custom-checkbox input:checked~.checkmark {
  background-color: #083943;
}

.checkmark:after {
  content: "";
  position: absolute;
  display: none;
}

.custom-checkbox input:checked~.checkmark:after {
  display: block;
}

.custom-checkbox .checkmark:after {
  left: 7px;
  top: 2px;
  width: 4px;
  height: 9px;
  border: solid white;
  border-width: 0 3px 3px 0;
  -webkit-transform: rotate(45deg);
  -ms-transform: rotate(45deg);
  transform: rotate(45deg);
}

/* Custom check box end */

/* Search Panel Start */
.search-box {
  position: relative;
  padding: 10px 10px;
}

.search-panel {
  width: 100%;
  border: 1px solid #dddddd;
  padding: 10px 10px 8px 35px;
  border-radius: 13px;
}

.search-icon {
  position: absolute;
  top: 50%;
  left: 20px;
  transform: translate(0%, -50%);
}

/* Search Panel End */

/* Loader Start */
#response-loading {
  display: none;
  position: relative;
  padding: 0px 0px 0px 10px;
  align-items: center;
}

#response-loading p {
  font-weight: 400;
  font-size: 16px;
  line-height: 19px;
}

.loading-image {
  padding-left: 5px;
  width: 30px;
  height: 30px;
}

.loader-block {
  position: fixed;
  top: 0;
  left: 0;
  max-width: 100%;
  width: 100%;
  height: 100%;
  display: none;
  justify-content: center;
  align-items: center;
  z-index: 500;
}

#loading-bar-spinner.spinner {
  animation: loading-bar-spinner 1000ms linear infinite;
}

#loading-bar-spinner.spinner .spinner-icon {
  width: 70px;
  height: 70px;
  border: solid 10px transparent;
  border-top-color: #083943 !important;
  border-left-color: #083943 !important;
  border-radius: 50%;
}

@keyframes loading-bar-spinner {
  0% {
    transform: rotate(0deg);
    transform: rotate(0deg);
  }

  100% {
    transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

/* Loader End */

/* Collapsible Starts */
.collapse-btn {
  border: none;
  border-bottom: 1px solid #e3e3e3;
  width: 100%;
}

.collapse-btn img {
  transform: rotate(0deg);
  transition: all 0.5s ease;
  pointer-events: none;
}

.collapse-btn.active img {
  transform: rotate(180deg);
  transition: all 0.5s ease;
  pointer-events: none;
}

/* Collapsible End */

/* Settings Start */
.settings-switch {
  width: auto;
  display: flex;
  align-items: center;
  justify-content: space-between;
  cursor: pointer;
  font-size: 14px;
  color: #333333;
  padding: 10px 15px;
}

.settings-switch h5 {
  margin: 0;
}

.custom-switch {
  position: relative;
  display: inline-block;
  width: 40px;
  height: 24px;
}

.custom-switch input {
  opacity: 0;
  width: 0;
  height: 0;
}

.custom-switch .slider-round {
  position: absolute;
  cursor: pointer;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #ccc;
  -webkit-transition: 0.4s;
  transition: 0.4s;
}

.custom-switch .slider-round:before {
  position: absolute;
  content: "";
  height: 18px;
  width: 18px;
  left: 3px;
  bottom: 3px;
  background-color: white;
  -webkit-transition: 0.4s;
  transition: 0.4s;
}

.custom-switch input:checked+.slider-round {
  background-color: #083943;
}

.custom-switch input:focus+.slider-round {
  box-shadow: 0 0 1px #083943;
}

.custom-switch input:checked+.slider-round:before {
  -webkit-transform: translateX(16px);
  -ms-transform: translateX(16px);
  transform: translateX(16px);
}

.custom-switch .slider-round {
  border-radius: 34px;
}

.custom-switch .slider-round:before {
  border-radius: 50%;
}

.setting-link {
  cursor: pointer;
  margin-left: 5px;
  border: none;
  background-color: initial;
  padding: 0px;
}

.slide-btn-container {
  width: 90%;
  padding: 10px 15px 20px 10px;
}

.slider-panel {
  -webkit-appearance: none;
  width: 90%;
  height: 9px;
  background: #d3d3d3;
  outline: none;
  opacity: 0.7;
  -webkit-transition: 0.2s;
  transition: opacity 0.2s;
  border-radius: 20px;
}

.slider-panel:hover {
  opacity: 1;
}

.slider-panel::-webkit-slider-thumb {
  -webkit-appearance: none;
  appearance: none;
  width: 20px;
  height: 20px;
  background: #107386;
  cursor: pointer;
  border-radius: 20px;
}

.slider-panel::-moz-range-thumb {
  width: 20px;
  height: 20px;
  background: #107386;
  cursor: pointer;
}

#range-value {
  color: #107386;
  margin-left: 10px;
  font-size: 18px;
  font-weight: bold;
}

/* Settings End */
</style>
